//file->AbstractMatrix.h

#import <AppKit/AppKit.h>
#import <EOInterface/EOInterface.h>
#import "AbstractBrowserCell.h"

@interface AbstractMatrix:NSMatrix
{
	NSEnumerator*		keys;
	NSObject*		propertyObject;
        id			draggedCell;
        id			floatingEditField;
}

- initWithFrame:(NSRect)frameRect mode:(int)aMode prototype:aCell numberOfRows:(int)numRows numberOfColumns:(int)numCols;
- (int)fillMatrixInBrowser:(NSBrowser*)aBrowser;
- (void)removeEditField;
- (void)setPropertyObject:(NSObject*)property;
- editCell:(AbstractBrowserCell*)aCell;
- (void)setKeys:(NSEnumerator*)theKeys;
- (NSString*)cellTitle:(NSObject*)key;
- (NSString*)newCellName;
- propertyObject;
- (int)count;
- (Class)cellClassForPropertyOnKey:aKey;
- (AbstractBrowserCell*)findCellWithTitle:(NSString*)title;
- (NSString*)defaultCellName:(NSString*)seedString;
- (NSString*)setDefaultName:(NSString*)name;

- (BOOL)saveNewValue:(NSDictionary*)dictionary;

- (void)dealloc;

@end
