//file->PropertyList.h

#import <EOInterface/EOInterface.h>

@interface PropertyList:NSObject
{
	id			pList;
	NSDictionary*		fileAttributes;
        NSMutableDictionary*	errorDictionary;

        BOOL			errorOccurred;
}

+ propertyWithContentsOfFile:(NSString*)filename;
+ propertyWithContentsOfString:(NSString*)string;

- initWithContentsOfFile:(NSString*)filename;
- initWithContentsOfString:(NSString*)string;
- (void)loadString:(NSString*)propertyString;
- (void)loadPropertyFromFile:(NSString*)filename;

- initAsDictionary;
- initAsArray;
- initAsArrayFromDictionary:(NSDictionary*)dictionary;
- (void)setObject:anObject toObject:anotherObject;
- propertyList;

- deepMutableCopy:pList;
- findObject:anObject;
- (NSString*)description;

//system independent file operations and attributes
- (BOOL)writeToFile:(NSString*)filename atomically:(BOOL)flag;
- (id)fileAttributesToFile:(NSString*)pathToFile;

//edit
- (BOOL)renameKey:key at:location withNewName:(NSString*)name;
- (void)addProperty:newProperty at:location withName:(NSString*)name;
- (BOOL)deleteProperty:(id*)oldProperty at:location withName:(NSString*)name;
- (void)parseError:(NSString*)reason precedingTokens:(NSArray*)tokens;

//error handling
- (NSDictionary*)errorDictionary;
- (BOOL)errorOccurred;

- (void)dealloc;

@end
